float gg = 9.81f;
float xA =  0.5f;
float   h  = 1.0f;
float   hh = h*0.5f;
float   r = 0.04f;
float   m = 1.0f;
float   J = 0.25f*m*r*r + (1.0f/12.0f)*m*h*h;
float pixel_pro_meter = 200.0f;


float dt = 0.001f;
float  t = 0.0f;

//Zustandsgrößen:
float  x    = 0.0;
float phi   = 0.5f;
float vx    = 0.0;
float omega = 0.0f;
float  x_alt    = 0.0;
float phi_alt   = 0.5f;
float vx_alt    = 0.0;
float omega_alt = 0.0f;

float     F = 0.0f;

float[][] punkte = {
                       {-r,0.0f}, //P1..P2 körpereigenes Koordinatensystem
                       { r,0.0f},
                       { r,h},
                       {-r,h}
                   };
float[][] punkte_trans = new float[4][2];

void transformieren(float[] quelle, float[] ziel, float xA, float phi)
{
     //  ziel = [xA,0] + T * quelle
     //T=
     //  cos(phi)  -sin(phi)
     //  sin(phi)   cos(phi)
     
     ziel[0] = xA   + quelle[0]*cos(phi) - quelle[1]*sin(phi);
     ziel[1] = 0.0f + quelle[0]*sin(phi) + quelle[1]*cos(phi);
}

float transFX(float x)
{
     return x*pixel_pro_meter+width/2;
}
float transFY(float y)
{
     return -y*pixel_pro_meter+height/2;
}

public void setup()
{
    size(800,600);
    frameRate( 1.0f/dt );
}

public float berechneXA(float x, float phi)
{
    return x + 0.5f*h*sin(phi);
}

public void draw()
{
//    F = -phi*200.0f;
//    F = -phi*60.0f;
//    F = -(phi-x*0.02f)*40.0f - omega - vx*vx;
  
     F = -100.0f*phi -omega +x +vx;
//     F = -10.0f*phi -omega -x -vx;
  
    //Eulerintegration der dynamischen Gleichungen:
    x     = x_alt     + dt*(vx_alt);
    vx    = vx_alt    + dt*(F/m);
    phi   = phi_alt   + dt*(omega_alt);
    omega=omega_alt+dt*((m*hh*sin(phi_alt)*(-hh*omega_alt*omega_alt*cos(phi_alt)+gg)
                         + hh*F*cos(phi_alt) )/
                            (J+m*hh*hh*sin(phi_alt)*sin(phi_alt))); 

    x_alt = x;
    vx_alt = vx;
    phi_alt = phi;
    omega_alt = omega;
    
    t+=dt;
                            
    background(0);
    stroke(255);
 
    line(0,height/2,width,height/2);
    
    xA = berechneXA(x,phi);
    float yA = 0.0f;
    float xB = xA - h*sin(phi);
    float yB =      h*cos(phi);
    
    line(transFX(xA),transFY(yA),transFX(xB),transFY(yB));

    for(int i=0;i<4;i++)
        transformieren(punkte[i],punkte_trans[i],xA,phi);
    stroke(255,0,0);    
    for(int i=0;i<4;i++)
    {
        line(transFX(punkte_trans[i][0]),transFY(punkte_trans[i][1]),
             transFX(punkte_trans[(i+1)%punkte_trans.length][0]),
             transFY(punkte_trans[(i+1)%punkte_trans.length][1]));        
    }
    
}
